Description

For some usecases catalog compilation might take a longer time, and when there's too many requests to Foreman and Passenger
decides to handle the request from node.rb by a freshly spawned worker, node.rb can hit the time out, fail to send the catalog to the
client, and the client's Puppet run ends with error.

The timeout is currently hardwired to 10 seconds in puppet-foreman. It should be configurable at least, and maybe raising the default
should be considered (especially due to the fresh Passenger worker issue described above).

Blocks this BZ https://bugzilla.redhat.com/show_bug.cqi?id=1188704

Associated revisions

Revision 5eb68ae8 - 02/10/2015 09:23 AM - Jiri Stransky

Fixes #9286 - node.rb timeout too low and not configurable

Make the node.rb timeout configurable. This is useful for use cases when
catalog compilation takes more time and/or the node.rb request to
Foreman is being handled by a freshly spawned Passenger worker.

Revision 8333351f - 02/10/2015 09:43 AM - Jiri Stransky
Fixes #9286 - node.rb timeout too low and not configurable
Make the node.rb timeout configurable. This is useful for use cases when

catalog compilation takes more time and/or the node.rb request to
Foreman is being handled by a freshly spawned Passenger worker.

History

#1 - 02/09/2015 05:28 AM - Ewoud Kohl van Wijngaarden

https://github.com/theforeman/puppet-foreman/blob/master/files/external_node_v2.rb#L 38-L40 reads the timeout from the config
(/etc/puppet/foreman.yaml) and only falls back to 10 if the :timeout value isn't found. That means it should be configurable, but it is true that
foreman::puppetmaster can't configure it.

#2 - 02/09/2015 05:32 AM - Jiri Stransky

Yeah i found that, i should have expressed myself better -- what i meant was that the value is not configurable by puppet-foreman and therefore it's
not configurable from foreman-installer's answer file. We use foreman-installer and we'd like to provide a higher default value for the parameter. |
could do it with “sed” after foreman-installer finishes, but it would be cleaner to do this by pre-setting this parameter in the answer file.

#3 - 02/09/2015 06:21 AM - Ewoud Kohl van Wijngaarden

Fair enough.

#4 - 02/09/2015 11:32 AM - Jiri Stransky

| hope to have pull request(s) tomorrow.

#5 - 02/10/2015 11:01 AM - Jiri Stransky

- Status changed from New to Closed
https://bugzilla.redhat.com/show_bug.cgi?id=1188704
https://github.com/theforeman/puppet-foreman/blob/master/files/external_node_v2.rb#L38-L40

- % Done changed from 0 to 100

Applied in changeset puppet-foreman|8333351feedb592f3fa01bb6c3765¢c6b782f5cdc.

#6 - 03/02/2015 05:45 AM - Dominic Cleal

- translation missing: en.field_release set to 28
https://projects.theforeman.org/projects/puppet-foreman/repository/puppet-foreman/revisions/8333351feedb592f3fa01bb6c3765c6b782f5cdc
